unit Unit31;

interface

uses
  Winapi.Windows, Winapi.Messages, System.SysUtils, System.Variants, System.Classes, Vcl.Graphics,
  Vcl.Controls, Vcl.Forms, Vcl.Dialogs, ScrMemo, ScrMps, atScript, atScripter, IDEMain;

type
  TForm31 = class(TForm)
    IDEMemo1: TIDEMemo;
    IDEScripter1: TIDEScripter;
    ScrPascalMemoStyler1: TScrPascalMemoStyler;
    IDEEngine1: TIDEEngine;
    procedure FormCreate(Sender: TObject);
//    procedure IDEMemo1GetAutoCompletionListIndex(Sender: TObject; AToken: string; AList: TStringList; var AIndex: Integer);
    procedure FormDestroy(Sender: TObject);
    procedure IDEMemo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
 //   procedure IDEMemo1GetParameterHint(Sender: TObject; AToken: string; var AParameterHint: string; var Handled: Boolean);
  private
    FCodeInsightContext:TCodeInsightContext;
    procedure _MyMethodProc(aMachine: TatVirtualMachine);
    procedure AdjustCompletionListToMemo(AList: TStrings);
    { Dclarations prives }
  public
    { Dclarations publiques }
  end;

var
  Form31: TForm31;

implementation

{$R *.dfm}

procedure TForm31.FormDestroy(Sender: TObject);
begin
FCodeInsightContext.Free;
end;


procedure TForm31.IDEMemo1KeyDown(Sender: TObject; var Key: Word; Shift: TShiftState);
var
  i:integer;
begin
  if  (ssShift in Shift) and (ssCtrl in Shift) and ( key=VK_ADD) then
  begin
    for I := IDEMemo1.cury+1 to IDEMemo1.VisibleLineCount-1 do
    begin
      if IDEMemo1.LineModified[i] then
      begin
          IDEMemo1.cury:=i;
           break;
      end;

    end;
  end
  else
  if  (ssShift in Shift) and (ssCtrl in Shift) and ( key=VK_SUBTRACT) then
  begin
    for I := IDEMemo1.cury-1 downto 0 do
    begin
      if IDEMemo1.LineModified[i] then
      begin
          IDEMemo1.cury:=i;
          break;
      end;

    end;
  end;

end;

procedure TForm31.AdjustCompletionListToMemo(AList: TStrings);
var
  e: integer;
  sl: TStrings;
  s: string;
  no: TObject;
begin
  sl := AList;
  for e := 1 to sl.Count do
  begin
    s := sl.Strings[e - 1];

    {$WARNINGS OFF}
    case integer(sl.Objects[e - 1]) of
    {$WARNINGS ON}
    0: sl.Strings[e - 1] := 'property ' + s;
    1,17: sl.Strings[e - 1] := 'procedure ' + s;
    2,18: sl.Strings[e - 1] := 'function ' + s;
    3,19: sl.Strings[e - 1] := 'event ' + s;
    16: sl.Strings[e - 1] := 'var ' + s
    else
      sl.Strings[e - 1] := s;
    end;

    // (ttNone, ttVar, ttProp, ttEvent, ttMethod, ttFunc, ttProc);
    {$WARNINGS OFF}
    case integer(sl.Objects[e - 1]) of
    {$WARNINGS ON}
      0: no := TObject(ttProp);
      1: no := TObject(ttMethod);
      2: no := TObject(ttMethod);
      3: no := TObject(ttEvent);
      16: no := TObject(ttVar);
      17: no := TObject(ttProc);
      18: no := TObject(ttFunc);
      19: no := TObject(ttEvent)
      else
        no := TObject(ttNone);
    end;
    sl.Objects[e - 1] := no;

  end;
  //tri
end;

 (*
procedure TForm31.IDEMemo1GetAutoCompletionListIndex(Sender: TObject; AToken: string; AList: TStringList; var AIndex: Integer);
var
  tp: integer;
  sl: tstringlist;
  CodeInsight: TScripterCodeInsight;
begin
 try
 // if  (IDEScripter1.Scripts[0]. Running) {or (ActiveScript = nil)} then
 //   Exit;

  AList.Clear;
  IDEMemo1.TextFromPos(IDEMemo1.CurX, IDEMemo1.CurY, tp);

  CodeInsight := TScripterCodeInsight.Create(IDEScripter1.Scripts[0], IDEMemo1.Lines.text);
  try
    CodeInsight.AvoidRecompilation := false;
    CodeInsight.Context := FCodeInsightContext;
    sl := CodeInsight.CreateCodeCompletionList(tp + 1, AIndex);
    try
      AdjustCompletionListToMemo(sl);
      AList.AddStrings(sl);
    finally
      sl.Free;
    end;
  finally
    CodeInsight.Free;
  end;
 finally

 end;
end;
  *)


(*
procedure TForm31.IDEMemo1GetParameterHint(Sender: TObject; AToken: string; var AParameterHint: string; var Handled: Boolean);
begin
    showmessage('Not executed');
end;
*)
procedure TForm31._MyMethodProc(aMachine:TatVirtualMachine);
begin

end;
procedure TForm31.FormCreate(Sender: TObject);
begin
   FCodeInsightContext:=TCodeInsightContext.Create;
   IDEScripter1.DefineMethod('MyMethod', 2, TkInteger, nil, _MyMethodProc, true, 0, 'Name:string;Value:integer');
   IDEEngine1.NewProject;
   IDEEngine1.NewUnit(TScriptLanguage.slPascal);
end;

end.
